# Programa para realizar el ordenamiento
# circular dos un conjunto de puntos de entrada
# Fraga 15.09.2021

import numpy as np
import insercion
import sys

n = len( sys.argv )
if n != 2 :
	print( "Args: archivo_puntos" )
	sys.exit(1)

A = np.fromfile( sys.argv[1], dtype=int, sep=" " )

# Aquí se leen todos los valores:
a = A.shape[0]

# Aquí lo cambio a una matriz de puntos:
n = int(a/2)
A = A.reshape( (n,2) )

# Aqui ya tengo los puntos leídos en una matriz de tamano n x 2 

# Podemos ordenar la matriz, o podemos ordenar los índices
# a esa matriz

# Voy a ordenar los índices, de esta forme resuelvo el
# problema de donde guardar el punto de referencia

# Paso 1, encontramos el punto con el menor 'y'
# indice al punto con el menor 'y'
ymin = 0
i = 1
while i < n :
	if A[i,1] < A[ymin,1] :
		ymin = i

	i += 1

print( "#", ymin )
	

# Paso 2, si hay varios puntos con el menor 'y',
# escogemos el de menor 'x'
xmin = ymin
i = 0
while i < n :
	if A[i,1] == A[xmin,1] and A[i,0] < A[xmin,0] :
		xmin = i

	i += 1

print( "#", xmin )

# Intercambio el punto encontrado con el punto en la posición '0'
# A[0,:] con el punto en A[xmin,:]
tmp = A[0,0] 
A[0,0] = A[xmin,0]
A[xmin,0] = tmp

tmp = A[0,1] 
A[0,1] = A[xmin,1]
A[xmin,1] = tmp

# Vamos a ordenar los puntos
# vamos a usar una indirección al ordenar los índices
indices = np.zeros( (n-1,), dtype=int )
i=1
while i < n :
	indices[i-1] = i
	i += 1

# Ordenamos los puntos
insercion.ordenar_por_insercion( A, indices )

print( A[0,0], A[0,1] )
i=0
while i < n-1 :
	j = indices[i]
	print( A[j,0], A[j,1] )
	i += 1
